"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var helpers_1 = require("./helpers");
var helpers_2 = require("./helpers");
function updateHTMLWithLinks(el, bind, vnode, userOptions) {
    if (userOptions === void 0) { userOptions = {}; }
    var argText = bind.value ? bind.value : '';
    var options = (0, helpers_2.defineOptions)(userOptions);
    var textExists = (0, helpers_1.getTextExistence)(el.innerHTML, argText);
    (0, helpers_2.handleWarningsAndErrors)(vnode, options, textExists);
    var innerText = (0, helpers_1.getInnerText)(textExists, el.innerHTML, argText);
    var innerSanitizedText = (0, helpers_2.sanitizeHTMLTags)(innerText);
    var validLinks = innerSanitizedText.match(options.urlRegEx);
    // First symbol of current textPartWithLink
    var startIdx = 0;
    // Last symbol of the link index
    var endIdx = 0;
    // Walk through text link by link, replacing each matched link
    // with <a href="" target=""> tag and adding all textPartWithLink to resultText
    var resultText = '';
    if (validLinks) {
        for (var _i = 0, validLinks_1 = validLinks; _i < validLinks_1.length; _i++) {
            var validLink = validLinks_1[_i];
            var linkTag = (0, helpers_1.compileLinkTag)(validLink, options.target);
            endIdx = innerSanitizedText.indexOf(validLink, startIdx) + validLink.length;
            var textPartWithLink = innerSanitizedText.substring(startIdx, endIdx);
            var textWithLinkTag = textPartWithLink.replace(validLink, linkTag);
            resultText += textWithLinkTag;
            startIdx = endIdx;
        }
        // Append text if left after linking:
        var resTextLengthDiff = endIdx < innerSanitizedText.length;
        if (resTextLengthDiff) {
            var ending = innerSanitizedText.slice(endIdx);
            resultText += ending;
        }
    }
    el.innerHTML = resultText.length > 0 ? resultText : innerSanitizedText;
}
exports.default = updateHTMLWithLinks;
